/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.29 Revision 1.122
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.29 2009/03/28 00:21:13 gengor Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.122 2012/03/01 15:19:14 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
15 13
16IUSE="${IUSE} custom-cxxflags debug pch"
17
18case "${PV}" in
19 4.?.?_rc*)
20 SRCTYPE="${SRCTYPE:-opensource-src}"
21 MY_PV="${PV/_rc/-rc}" 14MY_PV=${PV/_/-}
22 ;; 15MY_P=qt-everywhere-opensource-src-${MY_PV}
23 *) 16
24 SRCTYPE="${SRCTYPE:-opensource-src}" 17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
25 MY_PV="${PV}" 18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
26 ;; 19LICENSE="|| ( LGPL-2.1 GPL-3 )"
27esac 20
28MY_P=qt-x11-${SRCTYPE}-${MY_PV} 21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31DEPEND="dev-util/pkgconfig"
32RDEPEND="
33 !<x11-libs/qt-assistant-${PV}
34 !>x11-libs/qt-assistant-${PV}-r9999
35 !<x11-libs/qt-core-${PV}
36 !>x11-libs/qt-core-${PV}-r9999
37 !<x11-libs/qt-dbus-${PV}
38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
41 !<x11-libs/qt-demo-${PV}
42 !>x11-libs/qt-demo-${PV}-r9999
43 !<x11-libs/qt-gui-${PV}
44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
47 !<x11-libs/qt-opengl-${PV}
48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-openvg-${PV}
50 !>x11-libs/qt-openvg-${PV}-r9999
51 !<x11-libs/qt-phonon-${PV}
52 !>x11-libs/qt-phonon-${PV}-r9999
53 !<x11-libs/qt-qt3support-${PV}
54 !>x11-libs/qt-qt3support-${PV}-r9999
55 !<x11-libs/qt-script-${PV}
56 !>x11-libs/qt-script-${PV}-r9999
57 !<x11-libs/qt-sql-${PV}
58 !>x11-libs/qt-sql-${PV}-r9999
59 !<x11-libs/qt-svg-${PV}
60 !>x11-libs/qt-svg-${PV}-r9999
61 !<x11-libs/qt-test-${PV}
62 !>x11-libs/qt-test-${PV}-r9999
63 !<x11-libs/qt-webkit-${PV}
64 !>x11-libs/qt-webkit-${PV}-r9999
65 !<x11-libs/qt-xmlpatterns-${PV}
66 !>x11-libs/qt-xmlpatterns-${PV}-r9999
67"
68
29S=${WORKDIR}/${MY_P} 69S=${WORKDIR}/${MY_P}
30 70
31HOMEPAGE="http://www.qtsoftware.com/" 71# @FUNCTION: qt4-build_pkg_setup
32SRC_URI="http://download.qtsoftware.com/qt/source/${MY_P}.tar.bz2" 72# @DESCRIPTION:
33 73# Sets up PATH and LD_LIBRARY_PATH.
34case "${PV}" in
35 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
36 *) ;;
37esac
38
39if version_is_at_least 4.5 ${PV} ; then
40 LICENSE="|| ( LGPL-2.1 GPL-3 )"
41fi
42
43qt4-build_pkg_setup() { 74qt4-build_pkg_setup() {
44 # EAPI=2 ebuilds set use-deps, others need this: 75 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
45 if [[ $EAPI != 2 ]]; then 76
46 # Make sure debug setting corresponds with qt-core (bug 258512) 77 # Protect users by not allowing downgrades between releases
47 if [[ $PN != "qt-core" ]]; then 78 # Downgrading revisions within the same release should be allowed
48 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 79 if has_version '>'${CATEGORY}/${P}-r9999; then
49 ~x11-libs/qt-core-${PV} debug" 80 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
81 eerror "Sanity check to keep you from breaking your system:"
82 eerror " Downgrading Qt is completely unsupported and will break your system!"
83 die "aborting to save your system"
84 else
85 ewarn "Downgrading Qt is completely unsupported and will break your system!"
50 fi 86 fi
87 fi
51 88
52 # Check USE requirements 89 if [[ ${PN} == "qt-webkit" ]]; then
53 qt4-build_check_use 90 eshopts_push -s extglob
91 if is-flagq '-g?(gdb)?([1-9])'; then
92 echo
93 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
94 ewarn "You may experience really long compilation times and/or increased memory usage."
95 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
96 ewarn "For more info check out bug #307861"
97 echo
54 fi 98 fi
99 eshopts_pop
100 fi
55 101
56 # Set up installation directories
57 QTBASEDIR=/usr/$(get_libdir)/qt4
58 QTPREFIXDIR=/usr
59 QTBINDIR=/usr/bin
60 QTLIBDIR=/usr/$(get_libdir)/qt4
61 QTPCDIR=/usr/$(get_libdir)/pkgconfig
62 QTDATADIR=/usr/share/qt4
63 QTDOCDIR=/usr/share/doc/qt-${PV}
64 QTHEADERDIR=/usr/include/qt4
65 QTPLUGINDIR=${QTLIBDIR}/plugins
66 QTSYSCONFDIR=/etc/qt4
67 QTTRANSDIR=${QTDATADIR}/translations
68 QTEXAMPLESDIR=${QTDATADIR}/examples
69 QTDEMOSDIR=${QTDATADIR}/demos
70
71 PLATFORM=$(qt_mkspecs_dir)
72
73 PATH="${S}/bin:${PATH}" 102 PATH="${S}/bin${PATH:+:}${PATH}"
103 if [[ ${CHOST} != *-darwin* ]]; then
74 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 104 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
105 else
106 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
107 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
108 # platform detection. Note: needs to come before any directories to
109 # avoid extract failure.
110 [[ ${CHOST} == *-apple-darwin* ]] && \
111 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
112 ${QT4_EXTRACT_DIRECTORIES}"
113 fi
75 114
115 # Make sure ebuilds use the required EAPI
116 if [[ ${EAPI} != [234] ]]; then
117 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
118 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
119 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
120 die "qt4-build eclass requires EAPI 2,3 or 4"
121 fi
122
76 if ! version_is_at_least 4.1 $(gcc-version) ; then 123 if ! version_is_at_least 4.1 $(gcc-version); then
77 ewarn "Using a GCC version lower than 4.1 is not supported!" 124 ewarn "Using a GCC version lower than 4.1 is not supported!"
78 echo
79 ebeep 5
80 fi 125 fi
81
82 if use custom-cxxflags; then
83 echo
84 ewarn "You have set USE=custom-cxxflags, which means Qt will be built with the"
85 ewarn "CXXFLAGS you have set in /etc/make.conf. This is not supported, and we"
86 ewarn "recommend to unset this useflag. But you are free to experiment with it."
87 ewarn "Just do not start crying if it breaks your system, or eats your kitten"
88 ewarn "for breakfast. ;-) "
89 echo
90 fi
91
92} 126}
93 127
128# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
129# @DESCRIPTION:
130# Arguments for build_target_directories. Takes the directories in which the
131# code should be compiled. This is a space-separated list.
132
133# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
137
138# @FUNCTION: qt4-build_src_unpack
139# @DESCRIPTION:
140# Unpacks the sources.
94qt4-build_src_unpack() { 141qt4-build_src_unpack() {
95 local target targets licenses 142 setqtenv
96 if version_is_at_least 4.5 ${PV} ; then 143
97 licenses="LICENSE.GPL3 LICENSE.LGPL" 144 local tarball="${MY_P}.tar.gz" target= targets=
98 else 145 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
99 licenses="LICENSE.GPL2 LICENSE.GPL3"
100 fi
101 for target in configure ${licenses} projects.pro \
102 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 146 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
103 ${QT4_EXTRACT_DIRECTORIES}; do 147 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
148 do
104 targets="${targets} ${MY_P}/${target}" 149 targets+="${MY_P}/${target} "
105 done 150 done
106 151
107 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 152 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
108 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 153 tar -xzf "${DISTDIR}/${tarball}" ${targets}
109 154 eend $? || die "failed to unpack"
110 case "${PV}" in
111 4.4.?)
112 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
113 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
114 ;;
115 esac
116
117 # Be backwards compatible for now
118 if [[ $EAPI != 2 ]]; then
119 qt4-build_src_prepare
120 fi
121} 155}
122 156
157# @ECLASS-VARIABLE: PATCHES
158# @DEFAULT_UNSET
159# @DESCRIPTION:
160# PATCHES array variable containing all various patches to be applied.
161# This variable is expected to be defined in global scope of ebuild.
162# Make sure to specify the full path. This variable is utilised in
163# src_unpack/src_prepare phase, based on EAPI.
164#
165# @CODE
166# PATCHES=( "${FILESDIR}/mypatch.patch"
167# "${FILESDIR}/patches_folder/" )
168# @CODE
169
170# @FUNCTION: qt4-build_src_prepare
171# @DESCRIPTION:
172# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
173# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
123qt4-build_src_prepare() { 174qt4-build_src_prepare() {
175 setqtenv
124 cd "${S}" 176 cd "${S}"
125 177
178 if version_is_at_least "4.7"; then
179 # fix libX11 dependency on non X packages
180 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
181 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
182
183 qt_assistant_cleanup
184 fi
185
186 if use aqua; then
187 # provide a proper macx-g++-64
188 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
189
190 sed -e '/^CONFIG/s:app_bundle::' \
191 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
192 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
193 fi
194
126 if [[ ${PN} != qt-core ]]; then 195 if [[ ${PN} != qt-core ]]; then
127 skip_qmake_build_patch 196 skip_qmake_build
128 skip_project_generation_patch 197 skip_project_generation
129 symlink_binaries_to_buildtree 198 symlink_binaries_to_buildtree
130 fi 199 fi
131 200
132 if ! use custom-cxxflags;then 201 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
133 # Don't let the user go too overboard with flags. 202 # qmake bus errors with -O2 but -O3 works
134 strip-flags
135 replace-flags -O3 -O2 203 replace-flags -O2 -O3
204 fi
205
206 # Bug 178652
207 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
208 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
209 append-flags -fno-gcse
210 fi
211
212 if use_if_iuse c++0x; then
213 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
214 ewarn "this is an official standard, some of the reverse dependencies"
215 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
216 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
217 ewarn "disabled."
218 append-flags -std=c++0x
136 fi 219 fi
137 220
138 # Unsupported old gcc versions - hardened needs this :( 221 # Unsupported old gcc versions - hardened needs this :(
139 if [[ $(gcc-major-version) -lt "4" ]] ; then 222 if [[ $(gcc-major-version) -lt 4 ]]; then
140 ewarn "Appending -fno-stack-protector to CXXFLAGS" 223 ewarn "Appending -fno-stack-protector to CXXFLAGS"
141 append-cxxflags -fno-stack-protector 224 append-cxxflags -fno-stack-protector
142 fi
143
144 # Bug 178652
145 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then
146 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
147 append-flags -fno-gcse
148 fi
149
150 # Bug 253127 225 # Bug 253127
151 if [[ $(gcc-major-version) -lt "4" ]] ; then
152 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 226 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
153 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 227 -i mkspecs/common/g++.conf || die
154 fi 228 fi
229
230 # Bug 261632
231 if use ppc64; then
232 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
233 append-flags -mminimal-toc
234 fi
235
236 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
237 sed -e "/^SYSTEM_VARIABLES=/i \
238 CC='$(tc-getCC)'\n\
239 CXX='$(tc-getCXX)'\n\
240 CFLAGS='${CFLAGS}'\n\
241 CXXFLAGS='${CXXFLAGS}'\n\
242 LDFLAGS='${LDFLAGS}'\n" \
243 -i configure \
244 || die "sed SYSTEM_VARIABLES failed"
245
246 # Respect CC, CXX, LINK and *FLAGS in config.tests
247 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
248 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
249 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
250 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
251 || die "sed config.tests failed"
252
253 # Strip predefined CFLAGS from mkspecs (bug 312689)
254 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
155 255
156 # Bug 172219 256 # Bug 172219
257 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
258
259 if [[ ${CHOST} == *-darwin* ]]; then
260 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
261 # crippled (by design) :/
262 sed \
157 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 263 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
158 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 264 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
159 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 265 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
160 -e "s:X11R6/::" \ 266 -e "s:-arch\s\w*::g" \
161 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 267 -i mkspecs/common/mac-g++.conf \
268 || die "sed mkspecs/common/mac-g++.conf failed"
162 269
163 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 270 # Fix configure's -arch settings that appear in qmake/Makefile and also
164 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 271 # fix arch handling (automagically duplicates our -arch arg and breaks
165 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 272 # pch). Additionally disable Xarch support.
166 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 273 sed \
274 -e "s:-arch i386::" \
275 -e "s:-arch ppc::" \
276 -e "s:-arch x86_64::" \
277 -e "s:-arch ppc64::" \
278 -e "s:-arch \$i::" \
279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
281 -e "s:-Xarch_x86_64::g" \
282 -e "s:-Xarch_ppc64::g" \
283 -i configure mkspecs/common/mac-g++.conf \
284 || die "sed -arch/-Xarch failed"
167 285
168} 286 # On Snow Leopard don't fall back to 10.5 deployment target.
287 if [[ ${CHOST} == *-apple-darwin10 ]]; then
288 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
289 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
290 -i configure mkspecs/common/mac-g++.conf \
291 || die "sed deployment target failed"
292 fi
293 fi
169 294
295 # this one is needed for all systems with a separate -liconv, apart from
296 # Darwin, for which the sources already cater for -liconv
297 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
298 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
299 -i config.tests/unix/iconv/iconv.pro \
300 || die "sed iconv.pro failed"
301 fi
302
303 # we need some patches for Solaris
304 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
306 # use GCC over SunStudio
307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
308 # do not flirt with non-Prefix stuff, we're quite possessive
309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
311
312 base_src_prepare
313}
314
315# @FUNCTION: qt4-build_src_configure
316# @DESCRIPTION:
317# Default configure phase
170qt4-build_src_configure() { 318qt4-build_src_configure() {
319 setqtenv
171 320
172 myconf="$(standard_configure_options) ${myconf}"
173
174 echo ./configure ${myconf}
175 ./configure ${myconf} || die "./configure failed"
176}
177
178qt4-build_src_compile() {
179 # Be backwards compatible for now
180 if [[ $EAPI != 2 ]]; then
181 qt4-build_src_configure
182 fi
183
184 build_directories "${QT4_TARGET_DIRECTORIES}"
185}
186
187qt4-build_src_install() {
188 install_directories "${QT4_TARGET_DIRECTORIES}"
189 install_qconfigs
190 fix_library_files
191}
192
193standard_configure_options() {
194 local myconf="" 321 local conf="
195 322 -prefix ${QTPREFIXDIR}
196 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 323 -bindir ${QTBINDIR}
197 324 -libdir ${QTLIBDIR}
198 # Disable visibility explicitly if gcc version isn't 4 325 -docdir ${QTDOCDIR}
199 if [[ "$(gcc-major-version)" -lt "4" ]]; then 326 -headerdir ${QTHEADERDIR}
200 myconf="${myconf} -no-reduce-exports" 327 -plugindir ${QTPLUGINDIR}
201 fi 328 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
202 329 -datadir ${QTDATADIR}
203 # precompiled headers doesn't work on hardened, where the flag is masked. 330 -translationdir ${QTTRANSDIR}
204 if use pch; then 331 -sysconfdir ${QTSYSCONFDIR}
205 myconf="${myconf} -pch" 332 -examplesdir ${QTEXAMPLESDIR}
206 else 333 -demosdir ${QTDEMOSDIR}
207 myconf="${myconf} -no-pch" 334 -opensource -confirm-license
208 fi 335 -shared -fast -largefile -stl -verbose
209 336 -nomake examples -nomake demos"
210 if use debug; then
211 myconf="${myconf} -debug -no-separate-debug-info"
212 else
213 myconf="${myconf} -release -no-separate-debug-info"
214 fi
215 337
216 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 338 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
217 # $(tc-arch). Therefore we convert it to supported values. 339 # $(tc-arch). Therefore we convert it to supported values.
218 case "$(tc-arch)" in 340 case "$(tc-arch)" in
219 amd64) myconf="${myconf} -arch x86_64" ;; 341 amd64|x64-*) conf+=" -arch x86_64" ;;
342 ppc-macos) conf+=" -arch ppc" ;;
220 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 343 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
344 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
345 x86-macos) conf+=" -arch x86" ;;
221 x86|x86-*) myconf="${myconf} -arch i386" ;; 346 x86|x86-*) conf+=" -arch i386" ;;
222 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 347 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
223 hppa|sh) myconf="${myconf} -arch generic" ;; 348 hppa|sh) conf+=" -arch generic" ;;
224 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 349 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
225 esac 350 esac
226 351
227 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath 352 conf+=" -platform $(qt_mkspecs_dir)"
228 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
229 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
230 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
231 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
232 -demosdir ${QTDEMOSDIR} -silent -fast
233 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
234 -reduce-relocations -nomake examples -nomake demos"
235 353
354 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
355
356 # debug/release
357 if use debug; then
358 conf+=" -debug"
359 else
360 conf+=" -release"
361 fi
362 conf+=" -no-separate-debug-info"
363
364 # exceptions USE flag
365 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
366
367 # disable RPATH on Qt >= 4.8 (bug 380415)
368 version_is_at_least 4.8 && conf+=" -no-rpath"
369
370 # precompiled headers don't work on hardened, where the flag is masked
371 conf+=" $(qt_use pch)"
372
373 # -reduce-relocations
374 # This flag seems to introduce major breakage to applications,
375 # mostly to be seen as a core dump with the message "QPixmap: Must
376 # construct a QApplication before a QPaintDevice" on Solaris.
377 # -- Daniel Vergien
378 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
379
380 # this one is needed for all systems with a separate -liconv, apart from
381 # Darwin, for which the sources already cater for -liconv
382 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
383 conf+=" -liconv"
384 fi
385
386 if use_if_iuse glib; then
387 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
388 # avoid the -pthread argument
389 conf+=" ${glibflags//-pthread}"
390 unset glibflags
391 fi
392
393 if use_if_iuse qpa; then
394 ewarn
395 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
396 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
397 ewarn "disable it before reporting any bugs related to this useflag."
398 ewarn
399 conf+=" -qpa"
400 fi
401
402 if use aqua; then
403 # On (snow) leopard use the new (frameworked) cocoa code.
404 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
405 conf+=" -cocoa -framework"
406 # We need the source's headers, not the installed ones.
407 conf+=" -I${S}/include"
408 # Add hint for the framework location.
409 conf+=" -F${QTLIBDIR}"
410
411 # We are crazy and build cocoa + qt3support :-)
412 if use qt3support; then
413 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
414 -i configure || die
415 fi
416 else
417 conf+=" -no-framework"
418 fi
419 else
420 # freetype2 include dir is non-standard, thus pass it to configure
421 conf+=" $(pkg-config --cflags-only-I freetype2)"
422 fi
423
236 echo "${myconf}" 424 conf+=" ${myconf}"
237} 425 myconf=
238 426
427 echo ./configure ${conf}
428 ./configure ${conf} || die "./configure failed"
429
430 prepare_directories ${QT4_TARGET_DIRECTORIES}
431}
432
433# @FUNCTION: qt4-build_src_compile
434# @DESCRIPTION:
435# Actual compile phase
436qt4-build_src_compile() {
437 setqtenv
438
439 build_directories ${QT4_TARGET_DIRECTORIES}
440}
441
442# @FUNCTION: qt4-build_src_test
443# @DESCRIPTION:
444# Runs tests only in target directories.
445qt4-build_src_test() {
446 # QtMultimedia does not have any test suite (bug #332299)
447 [[ ${PN} == "qt-multimedia" ]] && return
448
449 for dir in ${QT4_TARGET_DIRECTORIES}; do
450 emake -j1 check -C ${dir}
451 done
452}
453
454# @FUNCTION: fix_includes
455# @DESCRIPTION:
456# For MacOS X we need to add some symlinks when frameworks are
457# being used, to avoid complications with some more or less stupid packages.
458fix_includes() {
459 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
460 # Some packages tend to include <Qt/...>
461 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
462
463 # Fake normal headers when frameworks are installed... eases life later on
464 local dest f h
465 for frw in "${D}${QTLIBDIR}"/*.framework; do
466 [[ -e "${frw}"/Headers ]] || continue
467 f=$(basename ${frw})
468 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
469 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
470
471 # Link normal headers as well.
472 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
473 h=$(basename ${hdr})
474 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
475 done
476 done
477 fi
478}
479
480# @FUNCTION: qt4-build_src_install
481# @DESCRIPTION:
482# Perform the actual installation including some library fixes.
483qt4-build_src_install() {
484 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
485 setqtenv
486
487 install_directories ${QT4_TARGET_DIRECTORIES}
488 install_qconfigs
489 fix_library_files
490 fix_includes
491
492 # remove .la files since we are building only shared Qt libraries
493 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
494}
495
496# @FUNCTION: setqtenv
497# @INTERNAL
498setqtenv() {
499 # Set up installation directories
500 QTPREFIXDIR=${EPREFIX}/usr
501 QTBINDIR=${EPREFIX}/usr/bin
502 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
503 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
504 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
505 QTHEADERDIR=${EPREFIX}/usr/include/qt4
506 QTPLUGINDIR=${QTLIBDIR}/plugins
507 QTIMPORTDIR=${QTLIBDIR}/imports
508 QTDATADIR=${EPREFIX}/usr/share/qt4
509 QTTRANSDIR=${QTDATADIR}/translations
510 QTSYSCONFDIR=${EPREFIX}/etc/qt4
511 QTEXAMPLESDIR=${QTDATADIR}/examples
512 QTDEMOSDIR=${QTDATADIR}/demos
513 QMAKE_LIBDIR_QT=${QTLIBDIR}
514 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
515
516 PLATFORM=$(qt_mkspecs_dir)
517
518 unset QMAKESPEC
519}
520
521# @FUNCTION: prepare_directories
522# @USAGE: < directories >
523# @INTERNAL
524# @DESCRIPTION:
525# Generates Makefiles for the given list of directories.
526prepare_directories() {
527 for x in "$@"; do
528 pushd "${S}"/${x} >/dev/null || die
529 einfo "Running qmake in: ${x}"
530 # avoid running over the maximum argument number, bug #299810
531 {
532 echo "${S}"/mkspecs/common/*.conf
533 find "${S}" -name '*.pr[io]'
534 } | xargs sed -i \
535 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
536 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
537 || die
538 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
539 popd >/dev/null || die
540 done
541}
542
543
544# @FUNCTION: build_directories
545# @USAGE: < directories >
546# @INTERNAL
547# @DESCRIPTION:
548# Compiles the code in the given list of directories.
239build_directories() { 549build_directories() {
240 local dirs="$@"
241 for x in ${dirs}; do 550 for x in "$@"; do
242 cd "${S}"/${x} 551 pushd "${S}"/${x} >/dev/null || die
243 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 552 emake CC="$(tc-getCC)" \
244 emake || die "emake failed" 553 CXX="$(tc-getCXX)" \
554 LINK="$(tc-getCXX)" || die "emake failed"
555 popd >/dev/null || die
245 done 556 done
246} 557}
247 558
559# @FUNCTION: install_directories
560# @USAGE: < directories >
561# @INTERNAL
562# @DESCRIPTION:
563# Runs emake install in the given directories, which are separated by spaces.
248install_directories() { 564install_directories() {
249 local dirs="$@"
250 for x in ${dirs}; do 565 for x in "$@"; do
251 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 566 pushd "${S}"/${x} >/dev/null || die
252 emake INSTALL_ROOT="${D}" install || die "emake install failed" 567 emake INSTALL_ROOT="${D}" install || die "emake install failed"
253 popd >/dev/null || die "Can't popd from ${S}/${x}" 568 popd >/dev/null || die
254 done 569 done
255} 570}
256 571
257# @ECLASS-VARIABLE: QCONFIG_ADD 572# @ECLASS-VARIABLE: QCONFIG_ADD
258# @DESCRIPTION: 573# @DESCRIPTION:
259# List options that need to be added to QT_CONFIG in qconfig.pri 574# List options that need to be added to QT_CONFIG in qconfig.pri
260QCONFIG_ADD="${QCONFIG_ADD:-}" 575: ${QCONFIG_ADD:=}
261 576
262# @ECLASS-VARIABLE: QCONFIG_REMOVE 577# @ECLASS-VARIABLE: QCONFIG_REMOVE
263# @DESCRIPTION: 578# @DESCRIPTION:
264# List options that need to be removed from QT_CONFIG in qconfig.pri 579# List options that need to be removed from QT_CONFIG in qconfig.pri
265QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 580: ${QCONFIG_REMOVE:=}
266 581
267# @ECLASS-VARIABLE: QCONFIG_DEFINE 582# @ECLASS-VARIABLE: QCONFIG_DEFINE
268# @DESCRIPTION: 583# @DESCRIPTION:
269# List variables that should be defined at the top of QtCore/qconfig.h 584# List variables that should be defined at the top of QtCore/qconfig.h
270QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 585: ${QCONFIG_DEFINE:=}
271 586
587# @FUNCTION: install_qconfigs
588# @INTERNAL
589# @DESCRIPTION:
590# Install gentoo-specific mkspecs configurations.
272install_qconfigs() { 591install_qconfigs() {
273 local x 592 local x
274 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 593 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
275 for x in QCONFIG_ADD QCONFIG_REMOVE; do 594 for x in QCONFIG_ADD QCONFIG_REMOVE; do
276 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 595 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
277 done 596 done
278 insinto ${QTDATADIR}/mkspecs/gentoo 597 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
279 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 598 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
280 fi 599 fi
281 600
282 if [[ -n ${QCONFIG_DEFINE} ]]; then 601 if [[ -n ${QCONFIG_DEFINE} ]]; then
283 for x in ${QCONFIG_DEFINE}; do 602 for x in ${QCONFIG_DEFINE}; do
284 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 603 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
285 done 604 done
286 insinto ${QTHEADERDIR}/Gentoo 605 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
287 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 606 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
288 fi 607 fi
289} 608}
290 609
610# @FUNCTION: generate_qconfigs
611# @INTERNAL
612# @DESCRIPTION:
613# Generates gentoo-specific qconfig.{h,pri}.
291generate_qconfigs() { 614generate_qconfigs() {
292 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 615 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
293 local x qconfig_add qconfig_remove qconfig_new 616 local x qconfig_add qconfig_remove qconfig_new
294 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 617 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
295 [[ -f ${x} ]] || continue 618 [[ -f ${x} ]] || continue
296 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 619 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
297 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 620 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
298 done 621 done
299 622
300 # these error checks do not use die because dying in pkg_post{inst,rm} 623 # these error checks do not use die because dying in pkg_post{inst,rm}
301 # just makes things worse. 624 # just makes things worse.
302 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 625 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
309 632
310 # generate list of QT_CONFIG entries from the existing list 633 # generate list of QT_CONFIG entries from the existing list
311 # including qconfig_add and excluding qconfig_remove 634 # including qconfig_add and excluding qconfig_remove
312 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 635 for x in $(sed -n 's/^QT_CONFIG +=//p' \
313 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 636 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
314 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 637 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
315 done 638 done
316 639
317 # replace the existing QT_CONFIG list with qconfig_new 640 # replace the existing QT_CONFIG list with qconfig_new
318 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 641 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
319 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 642 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
342 "${ROOT}${QTHEADERDIR}" 2>/dev/null 665 "${ROOT}${QTHEADERDIR}" 2>/dev/null
343 fi 666 fi
344 fi 667 fi
345} 668}
346 669
670# @FUNCTION: qt4-build_pkg_postrm
671# @DESCRIPTION:
672# Regenerate configuration when the package is completely removed.
347qt4-build_pkg_postrm() { 673qt4-build_pkg_postrm() {
348 generate_qconfigs 674 generate_qconfigs
349} 675}
350 676
677# @FUNCTION: qt4-build_pkg_postinst
678# @DESCRIPTION:
679# Regenerate configuration, plus throw a message about possible
680# breakages and proposed solutions.
351qt4-build_pkg_postinst() { 681qt4-build_pkg_postinst() {
352 generate_qconfigs 682 generate_qconfigs
353 echo
354 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
355 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
356 ewarn "should recompile the packages providing these plugins. Also, make sure you"
357 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
358 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
359 ewarn
360 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
361 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
362 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
363 ewarn "configuration."
364 ewarn
365 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
366 echo
367} 683}
368 684
685# @FUNCTION: skip_qmake_build
686# @INTERNAL
687# @DESCRIPTION:
688# Patches configure to skip qmake compilation, as it's already installed by qt-core.
369skip_qmake_build_patch() { 689skip_qmake_build() {
370 # Don't need to build qmake, as it's already installed from qt-core
371 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 690 sed -i -e "s:if true:if false:g" "${S}"/configure || die
372} 691}
373 692
374skip_project_generation_patch() { 693# @FUNCTION: skip_project_generation
694# @INTERNAL
695# @DESCRIPTION:
375 # Exit the script early by throwing in an exit before all of the .pro files are scanned 696# Exit the script early by throwing in an exit before all of the .pro files are scanned.
697skip_project_generation() {
376 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 698 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
377 -i "${S}"/configure || die "Sed failed"
378} 699}
379 700
701# @FUNCTION: symlink_binaries_to_buildtree
702# @INTERNAL
703# @DESCRIPTION:
704# Symlinks generated binaries to buildtree, so they can be used during compilation time.
380symlink_binaries_to_buildtree() { 705symlink_binaries_to_buildtree() {
381 for bin in qmake moc uic rcc; do 706 for bin in qmake moc uic rcc; do
382 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 707 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
383 done 708 done
384} 709}
385 710
711# @FUNCTION: fix_library_files
712# @INTERNAL
713# @DESCRIPTION:
714# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
715# moves the *.pc files into the pkgconfig directory.
386fix_library_files() { 716fix_library_files() {
717 local libfile
387 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 718 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
388 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
389 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 720 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
390 fi 721 fi
391 done 722 done
392 723
393 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 724 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
394 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 725 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
395 if [[ -e ${libfile} ]]; then 726 if [[ -e ${libfile} ]]; then
396 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 727 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
397 728
398 # Move .pc files into the pkgconfig directory 729 # Move .pc files into the pkgconfig directory
399
400 dodir ${QTPCDIR} 730 dodir ${QTPCDIR#${EPREFIX}}
401 mv ${libfile} "${D}"/${QTPCDIR}/ \ 731 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
402 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
403 fi 732 fi
404 done 733 done
405 734
406 # Don't install an empty directory 735 # Don't install an empty directory
407 rmdir "${D}"/${QTLIBDIR}/pkgconfig 736 rmdir "${D}"/${QTLIBDIR}/pkgconfig
408} 737}
409 738
739# @FUNCTION: qt_use
740# @USAGE: < flag > [ feature ] [ enableval ]
741# @DESCRIPTION:
742# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
743# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
744# will be used for that. If [enableval] is not specified, it omits the
745# "-${enableval}" part.
410qt_use() { 746qt_use() {
411 local flag="${1}" 747 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
412 local feature="${1}"
413 local enableval=
414
415 [[ -n ${2} ]] && feature=${2}
416 [[ -n ${3} ]] && enableval="-${3}"
417
418 if use ${flag}; then
419 echo "${enableval}-${feature}"
420 else
421 echo "-no-${feature}"
422 fi
423} 748}
424 749
425# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK 750# @FUNCTION: qt_mkspecs_dir
751# @RETURN: the specs-directory w/o path
426# @DESCRIPTION: 752# @DESCRIPTION:
427# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use 753# Allows us to define which mkspecs dir we want to use.
428# (eutils.eclass), line per line.
429#
430# Example:
431# @CODE
432# pkg_setup() {
433# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
434# ~x11-libs/qt-gui-${PV} qt3support"
435# qt4-build_check_use
436# }
437# @CODE
438
439# Run built_with_use on each flag and print appropriate error messages if any
440# flags are missing
441_qt_built_with_use() {
442 local missing opt pkg flag flags
443
444 if [[ ${1} = "--missing" ]]; then
445 missing="${1} ${2}" && shift 2
446 fi
447 if [[ ${1:0:1} = "-" ]]; then
448 opt=${1} && shift
449 fi
450
451 pkg=${1} && shift
452
453 for flag in "${@}"; do
454 flags="${flags} ${flag}"
455 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
456 flags="${flags}*"
457 else
458 [[ ${opt} = "-o" ]] && return 0
459 fi
460 done
461 if [[ "${flags# }" = "${@}" ]]; then
462 return 0
463 fi
464 if [[ ${opt} = "-o" ]]; then
465 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
466 else
467 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
468 fi
469 return 1
470}
471
472# @FUNCTION: qt4-build_check_use
473# @DESCRIPTION:
474# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
475# USE flags listed.
476#
477# If any of the required USE flags are missing, an eerror will be printed for
478# each package with missing USE flags.
479qt4-build_check_use() {
480 local line missing
481 while read line; do
482 [[ -z ${line} ]] && continue
483 if ! _qt_built_with_use ${line}; then
484 missing=true
485 fi
486 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
487 if [[ -n ${missing} ]]; then
488 echo
489 eerror "Flags marked with an * are missing."
490 die "Missing USE flags found"
491 fi
492}
493
494qt_mkspecs_dir() { 754qt_mkspecs_dir() {
495 # Allows us to define which mkspecs dir we want to use.
496 local spec 755 local spec=
497 756
498 case ${CHOST} in 757 case "${CHOST}" in
499 *-freebsd*|*-dragonfly*) 758 *-freebsd*|*-dragonfly*)
500 spec="freebsd" ;; 759 spec=freebsd ;;
501 *-openbsd*) 760 *-openbsd*)
502 spec="openbsd" ;; 761 spec=openbsd ;;
503 *-netbsd*) 762 *-netbsd*)
504 spec="netbsd" ;; 763 spec=netbsd ;;
505 *-darwin*) 764 *-darwin*)
765 if use aqua; then
766 # mac with carbon/cocoa
767 spec=macx
768 else
769 # darwin/mac with x11
506 spec="darwin" ;; 770 spec=darwin
771 fi
772 ;;
773 *-solaris*)
774 spec=solaris ;;
507 *-linux-*|*-linux) 775 *-linux-*|*-linux)
508 spec="linux" ;; 776 spec=linux ;;
509 *) 777 *)
510 die "Unknown CHOST, no platform choosen." 778 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
511 esac 779 esac
512 780
513 CXX=$(tc-getCXX) 781 case "$(tc-getCXX)" in
514 if [[ ${CXX/g++/} != ${CXX} ]]; then 782 *g++*)
515 spec="${spec}-g++" 783 spec+=-g++ ;;
516 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 784 *icpc*)
517 spec="${spec}-icc" 785 spec+=-icc ;;
518 else 786 *)
519 die "Unknown compiler ${CXX}." 787 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
788 esac
789
790 # Add -64 for 64bit profiles
791 if use x64-freebsd ||
792 use amd64-linux ||
793 use x64-macos ||
794 use x64-solaris ||
795 use sparc64-solaris
796 then
797 spec+=-64
520 fi 798 fi
521 799
522 echo "${spec}" 800 echo "${spec}"
523} 801}
524 802
525case ${EAPI:-0} in 803# @FUNCTION: qt_assistant_cleanup
526 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 804# @INTERNAL
805# @DESCRIPTION:
806# Tries to clean up tools.pro for qt-assistant ebuilds.
807# Meant to be called in src_prepare().
808# Since Qt 4.7.4 this function is a no-op.
809qt_assistant_cleanup() {
810 # apply patching to qt-assistant ebuilds only
811 [[ ${PN} != "qt-assistant" ]] && return
812
813 # no longer needed for 4.7.4 and later
814 version_is_at_least "4.7.4" && return
815
816 # different versions (and branches...) may need different handling,
817 # add a case if you need special handling
818 case "${MY_PV_EXTRA}" in
819 *kde-qt*)
820 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
821 -e "/mac/,/^embedded.*makeqpf$/d" \
822 -i tools/tools.pro || die "patching tools.pro failed"
823 ;;
824 *)
825 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
826 -e "/mac/,/^embedded.*makeqpf$/d" \
827 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
828 -i tools/tools.pro || die "patching tools.pro failed"
829 ;;
830 esac
831}
832
833# @FUNCTION: qt_nolibx11
834# @INTERNAL
835# @DESCRIPTION:
836# Ignore X11 tests for packages that don't need X libraries installed.
837qt_nolibx11() {
838 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
839 die "x11 check sed failed"
840}
841
527 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 842EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
528esac

Legend:
Removed from v.1.29  
changed lines
  Added in v.1.122

  ViewVC Help
Powered by ViewVC 1.1.20